<?php

// Run cron jobs for the current blog.
// (Use switch_to_blog() before calling this). 
function noblogs_run_cron_for_current_blog() {
  $crons = wp_get_ready_cron_jobs();

  foreach ($crons as $timestamp => $cronhooks) {
    foreach ($cronhooks as $hook => $keys) {
      foreach ($keys as $k => $v) {
        $args_str = implode(', ', $v['args']);
        echo "  {$k} -> {$hook} ({$args_str})\n";
        $schedule = $v['schedule'];
        if ($schedule) {
            $result = wp_reschedule_event($timestamp, $schedule, $hook, $v['args'], true);
            if (is_wp_error($result)) {
                error_log('cron reschedule event error for hook: %1$s, code: %2$s, message: %3$s, data: %4%s',
                          $hook, $result->get_error_code(), $result->get_error_message(), wp_json_encode($v));
                do_action('cron_reschedule_event_error', $result, $hook, $v);
            }
        }
        $result = wp_unschedule_event($timestamp, $hook, $v['args'], true);
        if (is_wp_error($result)) {
            error_log('cron unschedule event error for hook: %1$s, code: %2$s, message: %3$s, data: %4%s',
                      $hook, $result->get_error_code(), $result->get_error_message(), wp_json_encode($v));
            do_action('cron_unschedule_event_error', $result, $hook, $v);
        }
        do_action_ref_array($hook, $v['args']);
      }
    }
  }
}
